# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
"""add download metrics view 1

Revision ID: 1aee35976c94
Revises: 565c61a53263
Create Date: 2021-03-31 11:57:31.893606

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "1aee35976c94"
down_revision = "565c61a53263"
branch_labels = None
depends_on = None


def upgrade():
    op.execute(
        """
    CREATE OR REPLACE VIEW ws_download_metrics as
    SELECT ce.capability_request_id as request_id,
       cr.capability_name as cap_name,
       ce.created_at as execution_created,
       ce.state as state,
       cr.parameters->>'product_locator' as product_locator,
       sp.filegroup_id,
       f.datasize
    FROM capability_executions ce
         JOIN capability_requests cr on cr.capability_request_id = ce.capability_request_id
         JOIN science_products sp on parameters->>'product_locator' = sp.science_product_locator
         JOIN filegroups f on sp.filegroup_id = f.parent_filegroup_id
    WHERE capability_name = 'test_download'
    """
    )


def downgrade():
    op.execute(
        """
    DROP VIEW IF EXISTS ws_download_metrics
    """
    )
